#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float progressValue;
uniform float size;
uniform vec4 u_color;
uniform int way;


void main(){
    
    vec4 tex = texture2D(CC_Texture0, v_texCoord);
    
    if(tex.a > 0.95)
    {
        float progress = progressValue;
        
        float diff;
        
        if(way == 0) // UP
        {
            progress += v_texCoord.y;
            diff = - progress;
        }
        else if(way == 1) // CROSS
        {
            progress += v_texCoord.y;
            diff = v_texCoord.x - progress;
        }
        else //if(way == 2) // RIGHT
        {
            diff = v_texCoord.x - progress;
        }
        
        if (diff <= size && diff > 0.0)
        {
            tex = tex + u_color * tex.a * u_color.a;
        }
    }
    
    gl_FragColor = tex * v_fragmentColor;
}
