#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float radius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
    if(texColor.a>0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        
        float i;
        
        vec2 dist = vec2(0.0);
        vec2 distAbs = vec2(0.0);
        
        for(i=1.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x,0)).a == 0.0)
            {
                dist.x = i;
                distAbs.x = i;
                break;
            }
            
            if(texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x,0)).a == 0.0)
            {
                dist.x = -i;
                distAbs.x = i;
                break;
            }
        }
        
        for(i=1.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(0,i*unit.y)).a == 0.0)
            {
                dist.y = i;
                distAbs.y = i;
                break;
            }
            
            if(texture2D(CC_Texture0, v_texCoord + vec2(0,-i*unit.y)).a == 0.0)
            {
                dist.y = -i;
                distAbs.y = i;
                break;
            }
        }
        
        if(dist.x != 0.0 && dist.y != 0.0)
        {
            float total = distAbs.x + distAbs.y;
            
            if(total < radius * 0.75)
            {
                gl_FragColor = vec4(0.0,0.0,0.0,0.0);
                return;
            }
            
            if(distAbs.y > radius * 0.25 && distAbs.x > radius * 0.25 && total < radius * 1.2)
            {
                float h =  radius * 0.25 + (total - radius) / 1.41421356237;
                
                if(h > radius * 0.2)
                {
                    h = radius * 0.2;
                }
                
                if(distAbs.y < distAbs.x)
                {
                    distAbs = distAbs * (1.0 - h / distAbs.y);
                }
                else
                {
                    distAbs = distAbs * (1.0 - h / distAbs.x);
                }
                
                gl_FragColor = texture2D(CC_Texture0, v_texCoord + vec2(dist.x < 0.0 ? -1.0 : 1.0,
                                                                        dist.y < 0.0 ? -1.0 : 1.0) * distAbs * unit);
                
                return;
            }
            
        }
    }
    
    gl_FragColor = texColor;
    
}
