#ifdef GL_ES
precision highp float;
#else

#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float radius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
    if(texColor.a > 0.1)
    {
        vec2 unit = 1.0 / resolution.xy;
        
        float i;
        
        vec2 dist = vec2(0.0);
        
        for(i=1.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x,0)).a == 0.0)
            {
                dist.x = i;
                break;
            }
            
            if(texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x,0)).a == 0.0)
            {
                dist.x = -i;
                break;
            }
        }
        
        for(i=1.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(0,i*unit.y)).a == 0.0)
            {
                dist.y = i;
                break;
            }
            
            if(texture2D(CC_Texture0, v_texCoord + vec2(0,-i*unit.y)).a == 0.0)
            {
                dist.y = -i;
                break;
            }
        }
        
        if(dist.x != 0.0 && dist.y != 0.0)
        {
            vec2 distAbs = abs(dist);
            
            if((radius - distAbs.x) * (radius - distAbs.x) + (radius-distAbs.y) * (radius - distAbs.y) > radius * radius)
            {
                gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
                return;
            }
        }
    }
    
    gl_FragColor = texColor;
    
}
