#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

uniform float shadowDirectionFactorX;
uniform float shadowDirectionFactorY;
uniform float r;
uniform float shadowSize;

void main(void)
{
    gl_FragColor = texture2D(CC_Texture0, v_texCoord);
    
    if(gl_FragColor.a < 0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        
        float x,y,t;
        
        float i;
        float dist = 0.0;
        
        for(i = 1.0; i < r; i += 1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, 0)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, 0)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(0, i*unit.y)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(0, -i*unit.y)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, i*unit.y)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, i*unit.y)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, -i*unit.y)).a > 0.1 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, -i*unit.y)).a > 0.1)
            {
                dist=i;
                break;
            }
        }
        
        if(dist != 0.0)
        {
            gl_FragColor.a = 0.2 * (r - dist) / r;
        }
        
        
        vec2 unitVec = unit * vec2(shadowDirectionFactorX, shadowDirectionFactorY);
        vec2 coord;
        
        for(x = -2.0; x <= 2.0; x += 1.0)
        {
            for(y = -2.0; y <= 2.0; y += 1.0)
            {
                if(y == 0.0 && x == 0.0)
                {
                    continue;
                }
                
                for(t = 5.0; t < shadowSize; t += 2.0)
                {
                    coord = v_texCoord + t * unitVec + 2.0 * vec2(x, y) * unit;
                    
                    if(texture2D(CC_Texture0, coord).a > 0.1)
                    {
                        gl_FragColor.a = gl_FragColor.a + (0.004 + ((shadowSize-t)/(shadowSize)) * 0.014);
                        
                        break;
                    }
                }
            }
        }
    }
    else
    {
        gl_FragColor = gl_FragColor - vec4(0.1, 0.1, 0.1, 0.0);
    }
    
}
