#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
    if(texColor.a > 0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        float r = blurRadius * 0.4;
        
        float dist=-1.0;
        
        for(float i=1.0;i<r;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, 0)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, 0)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(0, i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(0, -i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x, -i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x, -i*unit.y)).a == 0.0)
            {
                dist=i;
                break;
            }
        }
        
        //if(dist!=-1.0)
        if(dist!=-1.0 && dist > blurRadius * 0.1)
        {   
            /*if(dist < blurRadius * 0.1)
            {
                float col = 4.0;
                       
                gl_FragColor = (texColor*texColor.a + vec4(0,0,0,col * col))/(col+texColor.a);
                gl_FragColor.a = 1.0;
                return;
            }*/
                   
            float distMax = r - 1.0;
            
            float col = 1.3 * ((distMax - dist) / distMax);
                              
            gl_FragColor = (texColor*texColor.a + vec4(0,0,0,col * col))/(col+texColor.a);
            gl_FragColor.a = 1.0;
            return;
        }
    }
    
    gl_FragColor = texColor;
    
}

