#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform vec2 wallOffset;
uniform vec2 texFactor;

uniform float texRot;

//uniform float texAlpha;

uniform sampler2D wallTexture;

void main(void)
{
    vec2 dist = v_texCoord - vec2(0.5, 0.5);
    
    float rot = atan(dist.y, dist.x) + texRot;
    
    vec2 v_texCoord_new = vec2(0.5, 0.5) + vec2(cos(rot), sin(rot)) * length(dist);
    
    vec2 coord = (v_texCoord - vec2(0.5, 0.5)) * texFactor;

    vec4 wallData = texture2D(wallTexture, wallOffset + coord);
    
    if(wallData.a < 0.5)
    {
        gl_FragColor = vec4(0,0,0,0);
        return;
    }
    
    vec4 color = texture2D(CC_Texture0, v_texCoord_new);
    
    if(wallData.r + wallData.g + wallData.b  < 0.5)
    {
        gl_FragColor = color * 0.1;
    }
    else
    {
        gl_FragColor = color * 0.7;
    }
    
    
}
