#ifdef GL_ES
precision lowp float;
#endif

varying vec2 v_texCoord;
uniform vec2 wallOffset;
uniform vec2 texFactor;

uniform sampler2D wallTexture;

void main(void)
{
    vec4 wallData = texture2D(wallTexture, wallOffset + (v_texCoord - vec2(0.5, 0.5)) * texFactor + vec2(0.5, 0.5));
    
    if(wallData.a < 0.1)
    {
        gl_FragColor = vec4(0.0,0.0,0.0,0.0);
        return;
    }
    
    gl_FragColor = vec4(wallData.r, wallData.g, wallData.b, texture2D(CC_Texture0, v_texCoord).a * 0.3);
}
